local OptionObjects={}
local HealBot_Plugin_luVars={}
local HealBot_Plugin_SetSpellsForList={}
local HealBot_Plugin_ModifierKeyList={}
local HealBot_Plugin_BindsKeyList={}
local HealBot_Plugin_BindsKeyListRead={}
HealBot_Plugin_ExtraButtons_Config={}

local function HealBot_Plugin_Options_Timer()
    if not HealBot_Plugin_luVars["optionsTimer"] then
        HealBot_Plugin_luVars["optionsTimer"]=true
        C_Timer.After(0.2, HealBot_Plugin_ExtraButtons_Options_Timer)
    end
end

function HealBot_Plugin_Options_ExtraButtons()
    HealBot_Plugin_BindsKeyList,HealBot_Plugin_BindsKeyListRead=HealBot_Options_retBindLists()
	HealBot_Plugin_luVars["pluginId"]="ExtraButtons"
    HealBot_Plugin_luVars["addonId"]="HealBot_Plugin_ExtraButtons"
	HealBot_Plugin_luVars["OptionsFrame"]=HealBot_Options_PluginExtraButtonsFrame
    HealBot_Plugin_luVars["SetSpellsForListID"]=1
    HealBot_Plugin_luVars["ModifierKeyListID"]=1

	HealBot_Plugin_SetSpellsForList={   HEALBOT_OPTIONS_ENABLEDBARS,
                                        HEALBOT_OPTIONS_ENEMYBARS,
                                     }
    HealBot_Plugin_ModifierKeyList = {
                                        HEALBOT_WORDS_NONE,
                                        HEALBOT_OPTIONS_SHIFT,
                                        HEALBOT_OPTIONS_CTRL,
                                        HEALBOT_OPTIONS_ALT,
                                        HEALBOT_OPTIONS_SHIFT.."+"..HEALBOT_OPTIONS_CTRL,
                                        HEALBOT_OPTIONS_SHIFT.."+"..HEALBOT_OPTIONS_ALT,
                                        HEALBOT_OPTIONS_CTRL.."+"..HEALBOT_OPTIONS_ALT,
                                        HEALBOT_OPTIONS_SHIFT.."+"..HEALBOT_OPTIONS_CTRL.."+"..HEALBOT_OPTIONS_ALT
                                    }
end

local function HealBot_Plugin_InUse()
	if HealBot_Globals.PluginExtraButtons then
        if HealBot_Plugin_luVars["prevFrame"]~=OptionObjects["OptionFrameSpellsSelect"] then
            OptionObjects["OptionButton610Btn"]:Show()
            OptionObjects["OptionButton1115Btn"]:Show()
            OptionObjects["OptionButton1620Btn"]:Show()
            OptionObjects["OptionSetSpellsFor"]:Show()
            OptionObjects["OptionSetModifierKey"]:Show()
        end
		HealBot_Plugin_luVars["prevFrame"]:Show()
	else
		OptionObjects["OptionButton610Btn"]:Hide()
		OptionObjects["OptionButton1115Btn"]:Hide()
		OptionObjects["OptionButton1620Btn"]:Hide()
        OptionObjects["OptionSetSpellsFor"]:Hide()
        OptionObjects["OptionSetModifierKey"]:Hide()
		HealBot_Plugin_luVars["prevFrame"]:Hide()
	end
end

local function HealBot_Plugin_OnClick(self)
	if self:GetChecked() then
		HealBot_Globals.PluginExtraButtons=true
	else
		HealBot_Globals.PluginExtraButtons=false
	end
	HealBot_Plugin_InUse()
	HealBot_InitPlugins()
end

--------------------------------------------------------------------

local function HealBot_Plugin_Options_SetupFrame(frame, hide)
	frame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 8, edgeSize = 8,
		insets = { left = 0, right = 0, top = 0, bottom = 0, },
	})
	frame:SetBackdropColor(0,0,0,0);
	frame:SetPoint("TOPLEFT", -5, -210)
	frame:SetSize(600,380)
	if hide then
		frame:Hide()
	else 
		HealBot_Plugin_luVars["prevFrame"]=frame
	end
	frame.TextAvoid = frame:CreateFontString()
	frame.TextAvoid:SetFontObject(GameFontNormalSmall)
	frame.TextAvoid:SetPoint("TOP",-250,-20)
	frame.TextAvoid:SetJustifyH("CENTER")
	frame.TextAvoid:SetJustifyV("CENTER")
	frame.TextTarget = frame:CreateFontString()
	frame.TextTarget:SetFontObject(GameFontNormalSmall)
	frame.TextTarget:SetPoint("TOP",-180,-20)
	frame.TextTarget:SetJustifyH("CENTER")
	frame.TextTarget:SetJustifyV("CENTER")
	frame.TextTrinket = frame:CreateFontString()
	frame.TextTrinket:SetFontObject(GameFontNormalSmall)
	frame.TextTrinket:SetPoint("TOP",112,-30)
	frame.TextTrinket:SetJustifyH("CENTER")
	frame.TextTrinket:SetJustifyV("CENTER")
	frame.TextBinds = frame:CreateFontString()
	frame.TextBinds:SetFontObject(GameFontNormalSmall)
	frame.TextBinds:SetPoint("TOP",218,-30)
	frame.TextBinds:SetJustifyH("CENTER")
	frame.TextBinds:SetJustifyV("CENTER")
    frame.Txt = frame:CreateFontString()
    frame.Txt:SetFontObject(GameFontNormal)
    frame.Txt:SetPoint("BOTTOMRIGHT", -5 , 5)
    frame.TxtBindsNote1 = frame:CreateFontString()
    frame.TxtBindsNote2 = frame:CreateFontString()
    frame.TxtBindsNote1:SetFontObject(GameFontNormalSmall)
    frame.TxtBindsNote1:SetPoint("BOTTOMLEFT", 5 , 20)
    frame.TxtBindsNote2:SetFontObject(GameFontNormalSmall)
    frame.TxtBindsNote2:SetPoint("BOTTOMLEFT", 5 , 5)
end

local function HealBot_Plugin_Options_Setup_EditBox(editbox,parent,x,y,headertext, text)
	editbox:SetPoint("TOP",parent,x,y)
	editbox:SetTextInsets(2, 2, 2, 2)
	editbox:SetMaxLetters(30)
	editbox:SetWidth(150)
	editbox.Txt = editbox:CreateFontString()
	editbox.Txt:SetFontObject(GameFontNormalSmall)
	editbox.Txt:SetPoint("TOPLEFT", 0 , 12)
    editbox.Txt:SetText(headertext)
	editbox:SetText(text)
end

local function HealBot_Plugin_Options_SetupDropDown(dropdown, width, x, y, text)
	dropdown:SetPoint("TOP", x, y)
	UIDropDownMenu_SetWidth(dropdown, width)	
	dropdown.Txt = dropdown:CreateFontString()
	dropdown.Txt:SetFontObject(GameFontNormal)
	dropdown.Txt:SetPoint("TOP", 0 , 12)
    dropdown.Txt:SetText(text)
end

local function HealBot_Plugin_Options_PrepAttribs(newBind, index)
    if newBind and newBind>1 then 
        for x=1,20 do
            if x~=index and HealBot_Config_Spells.Binds[x]==newBind then
                HealBot_Config_Spells.Binds[x]=1
                HealBot_Timers_PluginsSet(4)
            end
        end
    end
    HealBot_Plugin_Options_InitBinds()
    HealBot_Timers_PluginsSet(3)
end

HealBot_Plugin_luVars["HealSpellsComboID"]=1
local function OptionsHelpDropdown1_DropDown()
    local info = UIDropDownMenu_CreateInfo()
    local hbHealDDlist=HealBot_Options_SelectHealSpellsCombo_DDlist(HealBot_Plugin_luVars["SetSpellsForListID"])
    if getn(hbHealDDlist)>0 then
        for j=1, getn(hbHealDDlist), 1 do
            info.text = hbHealDDlist[j];
            info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpHealSelect"] = self:GetText()
                        HealBot_Plugin_luVars["HealSpellsComboID"] = self:GetID()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown1"],hbHealDDlist[HealBot_Plugin_luVars["HealSpellsComboID"]]) 
                    end
            info.checked = false;
            if HealBot_Plugin_luVars["HealSpellsComboID"]==j then info.checked = true end
            UIDropDownMenu_AddButton(info);
        end
    else
        info.text = HEALBOT_TOOLTIP_NONE
        info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpHealSelect"] = nil
                        HealBot_Plugin_luVars["HealSpellsComboID"] = self:GetID()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown1"],HEALBOT_TOOLTIP_NONE) 
                    end
        info.checked = true;
        UIDropDownMenu_AddButton(info);
    end
end

HealBot_Plugin_luVars["OtherSpellsComboID"]=1
local function OptionsHelpDropdown2_DropDown()
    local info = UIDropDownMenu_CreateInfo()
    local hbOtherDDlist=HealBot_Options_SelectOtherSpellsCombo_DDlist()
    if getn(hbOtherDDlist)>0 then
        for j=1, getn(hbOtherDDlist), 1 do
            info.text = hbOtherDDlist[j];
            info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpOtherSelect"] = self:GetText()
                        HealBot_Plugin_luVars["OtherSpellsComboID"] = self:GetID()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown2"],hbOtherDDlist[HealBot_Plugin_luVars["OtherSpellsComboID"]]) 
                    end
            info.checked = false;
            if HealBot_Plugin_luVars["OtherSpellsComboID"]==j then info.checked = true end
            UIDropDownMenu_AddButton(info);
        end
    else
        info.text = HEALBOT_TOOLTIP_NONE
        info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpOtherSelect"] = nil
                        HealBot_Plugin_luVars["OtherSpellsComboID"] = self:GetID()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown2"],HEALBOT_TOOLTIP_NONE) 
                    end
        info.checked = true;
        UIDropDownMenu_AddButton(info);
    end
end

HealBot_Plugin_luVars["MacrosComboID"]=1
local HealBot_Plugin_Options_NoDuplcates={}
local function OptionsHelpDropdown3_DropDown(self, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    local macroList=HealBot_Options_UpdateMacrosList()    
    if level and getn(macroList)>10 then
        if level == 1 then
            for j=1, ceil(getn(macroList)/10), 1 do
                local n=j*10
                if n > getn(macroList) then n=getn(macroList) end
                info.text = "    "..((j*10)-9).." - "..n;
                info.hasArrow = true
                info.notCheckable = true
                info.menuList = j, true, j
                UIDropDownMenu_AddButton(info)
            end
        else
            local n=menuList*10
            if n > getn(macroList) then n=getn(macroList) end
            for j=((menuList*10)-9), n, 1 do
                local mText=macroList[j]
                info.text = mText
                info.func = function(self)
                                HealBot_Plugin_luVars["hbHelpMacroSelect"] = self:GetText()
                                HealBot_Plugin_luVars["MacrosComboID"] = self:GetID()
                                UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown3"],mText) 
                            end
                info.checked = false;
                if HealBot_Plugin_luVars["MacrosComboID"]==j then info.checked = true end
                UIDropDownMenu_AddButton(info, level)
            end
        end
    elseif getn(macroList)>0 then
        for j=1, getn(macroList), 1 do
            local mText=macroList[j]
            info.text = mText
            info.func = function(self)
                            HealBot_Plugin_luVars["hbHelpMacroSelect"] = self:GetText()
                            HealBot_Plugin_luVars["MacrosComboID"] = self:GetID()
                            UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown3"],mText) 
                        end
            info.checked = false;
            if HealBot_Plugin_luVars["MacrosComboID"]==j then info.checked = true end
            UIDropDownMenu_AddButton(info)
        end
    else
        info.text = HEALBOT_TOOLTIP_NONE
        info.func = function(self)
                        HealBot_Plugin_luVars["MacrosComboID"] = self:GetID()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown3"],HEALBOT_TOOLTIP_NONE) 
                    end
        info.checked = true;
        UIDropDownMenu_AddButton(info);
        HealBot_Plugin_luVars["hbHelpMacroSelect"]=nil
    end
end

HealBot_Plugin_luVars["ItemsComboID"]=1
local function OptionsHelpDropdown4_DropDown()
    local info = UIDropDownMenu_CreateInfo()
    local items=HealBot_Options_ItemsInBag(HealBot_Plugin_luVars["SetSpellsForListID"])
    table.sort(items)
    for j=1, getn(items), 1 do
        local iName = items[j];
        info.text = iName
        info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpItemSelect"] = self:GetText()
                        HealBot_Plugin_luVars["ItemsComboID"] = self:GetID()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown4"],iName) 
                    end
        info.checked = false;
        if HealBot_Plugin_luVars["ItemsComboID"]==j then info.checked = true end
        UIDropDownMenu_AddButton(info);
    end
end

local function OptionsHelpDropdown5_DropDown()
    local info = UIDropDownMenu_CreateInfo()
    local cmdList=HealBot_Options_SelectCmds_List(HealBot_Plugin_luVars["SetSpellsForListID"])
    for j=1, getn(cmdList), 1 do
        info.text = cmdList[j];
        info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpCmdsSelect"] = self:GetText()
                        HealBot_Plugin_luVars["CmdsComboID"] = self:GetID()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown5"],cmdList[HealBot_Plugin_luVars["CmdsComboID"]]) 
                    end
        info.checked = false;
        if HealBot_Plugin_luVars["CmdsComboID"]==j then info.checked = true end
        UIDropDownMenu_AddButton(info);
    end
end

local function OptionsHelpDropdown6_DropDown(self, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    if level == 1 then
        local emoteCatList=HealBot_Options_RetEmote_List("CAT")
        for j=1, getn(emoteCatList), 1 do
            info.text = "    "..emoteCatList[j];
            info.hasArrow = true
            info.notCheckable = true
            info.menuList = emoteCatList[j], true, emoteCatList[j]
            UIDropDownMenu_AddButton(info)
        end
    elseif menuList == HEALBOT_EMOTE_CAT_COMBAT then
        local emoteCombatList=HealBot_Options_RetEmote_List("COMBAT")
        for j=1, getn(emoteCombatList), 1 do
            info.text = emoteCombatList[j];
            info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpEmotesSelect"] = HEALBOT_EMOTE.."="..self:GetText()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown6"], self:GetText())
                    end
            info.checked = false;
            UIDropDownMenu_AddButton(info, level);
        end
    elseif menuList == HEALBOT_EMOTE_CAT_EMOTION then
        local emoteEmotionList=HealBot_Options_RetEmote_List("EMOTION")
        for j=1, getn(emoteEmotionList), 1 do
            info.text = emoteEmotionList[j];
            info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpEmotesSelect"] = HEALBOT_EMOTE.."="..self:GetText()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown6"], self:GetText())
                    end
            info.checked = false;
            UIDropDownMenu_AddButton(info, level);
        end
    elseif menuList == HEALBOT_EMOTE_CAT_HAPPY then
        local emoteHappyList=HealBot_Options_RetEmote_List("HAPPY")
        for j=1, getn(emoteHappyList), 1 do
            info.text = emoteHappyList[j];
            info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpEmotesSelect"] = HEALBOT_EMOTE.."="..self:GetText()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown6"], self:GetText())
                    end
            info.checked = false;
            UIDropDownMenu_AddButton(info, level);
        end
    elseif menuList == HEALBOT_EMOTE_CAT_GREET then
        local emoteGreetList=HealBot_Options_RetEmote_List("GREET")
        for j=1, getn(emoteGreetList), 1 do
            info.text = emoteGreetList[j];
            info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpEmotesSelect"] = HEALBOT_EMOTE.."="..self:GetText()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown6"], self:GetText())
                    end
            info.checked = false;
            UIDropDownMenu_AddButton(info, level);
        end
    elseif menuList == HEALBOT_EMOTE_CAT_OTHER then
        local emoteOtherList=HealBot_Options_RetEmote_List("OTHER")
        for j=1, getn(emoteOtherList), 1 do
            info.text = emoteOtherList[j];
            info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpEmotesSelect"] = HEALBOT_EMOTE.."="..self:GetText()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown6"], self:GetText())
                    end
            info.checked = false;
            UIDropDownMenu_AddButton(info, level);
        end
    elseif menuList == HEALBOT_EMOTE_CAT_RESPECT then
        local emoteRespectList=HealBot_Options_RetEmote_List("RESPECT")
        for j=1, getn(emoteRespectList), 1 do
            info.text = emoteRespectList[j];
            info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpEmotesSelect"] = HEALBOT_EMOTE.."="..self:GetText()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown6"], self:GetText())
                    end
            info.checked = false;
            UIDropDownMenu_AddButton(info, level);
        end
    elseif menuList == HEALBOT_EMOTE_CAT_UNHAPPY then
        local emoteUnhappyList=HealBot_Options_RetEmote_List("UNHAPPY")
        for j=1, getn(emoteUnhappyList), 1 do
            info.text = emoteUnhappyList[j];
            info.func = function(self)
                        HealBot_Plugin_luVars["hbHelpEmotesSelect"] = HEALBOT_EMOTE.."="..self:GetText()
                        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown6"], self:GetText())
                    end
            info.checked = false;
            UIDropDownMenu_AddButton(info, level);
        end
    end
end

local function OptionSetSpellsFor_DropDown()
    local info = UIDropDownMenu_CreateInfo()
    for j=1, 2, 1 do
        info.text = HealBot_Plugin_SetSpellsForList[j];
        info.func = function(self)
                        if HealBot_Plugin_luVars["SetSpellsForListID"]~=self:GetID() then
							HealBot_Plugin_luVars["SetSpellsForListID"]=self:GetID()
                            UIDropDownMenu_SetText(OptionObjects["OptionSetSpellsFor"],HealBot_Plugin_SetSpellsForList[HealBot_Plugin_luVars["SetSpellsForListID"]])
                            HealBot_Plugin_Options_Timer()
                        end
                    end
        info.checked = false;
        if HealBot_Plugin_luVars["SetSpellsForListID"]==j then info.checked = true end
        UIDropDownMenu_AddButton(info);
    end
end

local function OptionSetModifierKey_DropDown()
    local info = UIDropDownMenu_CreateInfo()
    for j=1, getn(HealBot_Plugin_ModifierKeyList), 1 do
        info.text = HealBot_Plugin_ModifierKeyList[j];
        info.func = function(self)
                        if HealBot_Plugin_luVars["ModifierKeyListID"]~=self:GetID() then
							HealBot_Plugin_luVars["ModifierKeyListID"]=self:GetID()
                            UIDropDownMenu_SetText(OptionObjects["OptionSetModifierKey"],HealBot_Plugin_ModifierKeyList[HealBot_Plugin_luVars["ModifierKeyListID"]])
                            HealBot_Plugin_Options_Timer()
                        end
                    end
        info.checked = false;
        if HealBot_Plugin_luVars["ModifierKeyListID"]==j then info.checked = true end
        UIDropDownMenu_AddButton(info);
    end
end

local function OptionBinds_Level1Info(info, index)
    for j=1, 3 do
        info.text = HealBot_Plugin_BindsKeyListRead[j];
        info.func = function(self)
                        if HealBot_Config_Spells.Binds[index]~=self:GetID() then
                            HealBot_Config_Spells.Binds[index]=self:GetID()
                            UIDropDownMenu_SetText(OptionObjects["OptionBindsB"..index],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[index]])
                            HealBot_Plugin_Options_PrepAttribs(HealBot_Config_Spells.Binds[index], index)
                        end
                    end
        info.checked = false;
        if HealBot_Config_Spells.Binds[index]==j then info.checked = true end
        UIDropDownMenu_AddButton(info, 1);
    end
    wipe(info)
    info.disabled = true
    info.notCheckable = true
    UIDropDownMenu_AddButton(info)
    info.disabled = false
    info.hasArrow = true
    info.notCheckable = true
    info.keepShownOnClick=false
    info.text = "     0 - 9"
    info.menuList = 1
    UIDropDownMenu_AddButton(info)
    info.text = "     NumPad 0 - 9"
    info.menuList = 2
    UIDropDownMenu_AddButton(info)
    info.text = "     A - M"
    info.menuList = 3
    UIDropDownMenu_AddButton(info)
    info.text = "     N - Z"
    info.menuList = 4
    UIDropDownMenu_AddButton(info)
    info.text = "     Nav Keys"
    info.menuList = 5
    UIDropDownMenu_AddButton(info)
end

local function OptionBinds_09_Info(info, level, index)
    for j=4, 13, 1 do
        info.text = HealBot_Plugin_BindsKeyListRead[j];
        info.func = function(self)
                        if HealBot_Config_Spells.Binds[index]~=self:GetID()+3 then
                            HealBot_Config_Spells.Binds[index]=self:GetID()+3
                            UIDropDownMenu_SetText(OptionObjects["OptionBindsB"..index],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[index]])
                            HealBot_Plugin_Options_PrepAttribs(HealBot_Config_Spells.Binds[index], index)
                        end
                    end
        info.checked = false;
        if HealBot_Config_Spells.Binds[index]==j then info.checked = true end
        UIDropDownMenu_AddButton(info, level);
    end
end

local function OptionBinds_num09_Info(info, level, index)
    for j=14, 23, 1 do
        info.text = HealBot_Plugin_BindsKeyListRead[j];
        info.func = function(self)
                        if HealBot_Config_Spells.Binds[index]~=self:GetID()+13 then
                            HealBot_Config_Spells.Binds[index]=self:GetID()+13
                            UIDropDownMenu_SetText(OptionObjects["OptionBindsB"..index],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[index]])
                            HealBot_Plugin_Options_PrepAttribs(HealBot_Config_Spells.Binds[index], index)
                        end
                    end
        info.checked = false;
        if HealBot_Config_Spells.Binds[index]==j then info.checked = true end
        UIDropDownMenu_AddButton(info, level);
    end
end

local function OptionBinds_am_Info(info, level, index)
    for j=24, 36, 1 do
        info.text = HealBot_Plugin_BindsKeyListRead[j];
        info.func = function(self)
                        if HealBot_Config_Spells.Binds[index]~=self:GetID()+23 then
                            HealBot_Config_Spells.Binds[index]=self:GetID()+23
                            UIDropDownMenu_SetText(OptionObjects["OptionBindsB"..index],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[index]])
                            HealBot_Plugin_Options_PrepAttribs(HealBot_Config_Spells.Binds[index], index)
                        end
                    end
        info.checked = false;
        if HealBot_Config_Spells.Binds[index]==j then info.checked = true end
        UIDropDownMenu_AddButton(info, level);
    end
end

local function OptionBinds_nz_Info(info, level, index)
    for j=37, 49, 1 do
        info.text = HealBot_Plugin_BindsKeyListRead[j];
        info.func = function(self)
                        if HealBot_Config_Spells.Binds[index]~=self:GetID()+36 then
                            HealBot_Config_Spells.Binds[index]=self:GetID()+36
                            UIDropDownMenu_SetText(OptionObjects["OptionBindsB"..index],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[index]])
                            HealBot_Plugin_Options_PrepAttribs(HealBot_Config_Spells.Binds[index], index)
                        end
                    end
        info.checked = false;
        if HealBot_Config_Spells.Binds[index]==j then info.checked = true end
        UIDropDownMenu_AddButton(info, level);
    end
end

function OptionBinds_nav_Info(info, level, index)
    for j=50, 59, 1 do
        info.text = HealBot_Plugin_BindsKeyListRead[j];
        info.func = function(self)
                        if HealBot_Config_Spells.Binds[index]~=self:GetID()+49 then
                            HealBot_Config_Spells.Binds[index]=self:GetID()+49
                            UIDropDownMenu_SetText(OptionObjects["OptionBindsB"..index],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[index]])
                            HealBot_Options_CheckBindsOnChange(HealBot_Config_Spells.Binds[index], index)
                        end
                    end
        info.checked = false;
        if HealBot_Config_Spells.Binds[index]==j then info.checked = true end
        UIDropDownMenu_AddButton(info, level);
    end
end

local function OptionBinds_DropDown(self, level, menuList, index)
    local info = UIDropDownMenu_CreateInfo()
    info.keepShownOnClick=false
    if level == 1 then
        OptionBinds_Level1Info(info, index)
    elseif menuList == 1 then
        OptionBinds_09_Info(info, level, index)
    elseif menuList == 2 then
        OptionBinds_num09_Info(info, level, index)
    elseif menuList == 3 then
        OptionBinds_am_Info(info, level, index)
    elseif menuList == 4 then
        OptionBinds_nz_Info(info, level, index)
    elseif menuList == 5 then
        OptionBinds_nav_Info(info, level, index)
    end
end

local function OptionBinds6_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 6)
end

local function OptionBinds7_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 7)
end

local function OptionBinds8_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 8)
end

local function OptionBinds9_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 9)
end

local function OptionBinds10_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 10)
end

local function OptionBinds11_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 11)
end

local function OptionBinds12_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 12)
end

local function OptionBinds13_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 13)
end

local function OptionBinds14_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 14)
end

local function OptionBinds15_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 15)
end

local function OptionBinds16_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 16)
end

local function OptionBinds17_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 17)
end

local function OptionBinds18_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 18)
end

local function OptionBinds19_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 19)
end

local function OptionBinds20_DropDown(self, level, menuList)
    OptionBinds_DropDown(self, level, menuList, 20)
end

local function HealBot_Plugin_Options_SetLabel(object, text)
	local r,g,b,a=HealBot_Options_OptionsThemeCols()
	object:SetText(text)
	object:SetTextColor(r,g,b,a)
end

local function HealBot_Plugin_Options_SetHelpSelectValues()
    UIDropDownMenu_Initialize(OptionObjects["OptionsHelpDropdown1"], OptionsHelpDropdown1_DropDown)
    if HealBot_Plugin_luVars["SetSpellsForListID"]>1 then
        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown1"],HEALBOT_OPTIONS_HARMFUL_SPELLS)
    else
        UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown1"], HEALBOT_OPTIONS_SMARTCASTHEAL)
    end	
    UIDropDownMenu_Initialize(OptionObjects["OptionsHelpDropdown2"], OptionsHelpDropdown2_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown2"], HEALBOT_OPTIONS_OTHERSPELLS)
    UIDropDownMenu_Initialize(OptionObjects["OptionsHelpDropdown3"], OptionsHelpDropdown3_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown3"], HEALBOT_WORD_MACROS)
    UIDropDownMenu_Initialize(OptionObjects["OptionsHelpDropdown4"], OptionsHelpDropdown4_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown4"], HEALBOT_OPTIONS_ITEMS)
    UIDropDownMenu_Initialize(OptionObjects["OptionsHelpDropdown5"], OptionsHelpDropdown5_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown5"], HEALBOT_WORD_COMMANDS)
    UIDropDownMenu_Initialize(OptionObjects["OptionsHelpDropdown6"], OptionsHelpDropdown6_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionsHelpDropdown6"], HEALBOT_EMOTE)
end

local function HealBot_Plugin_Frame_OnClick(frame, button)
	HealBot_Plugin_luVars["prevFrame"]:Hide()
    HealBot_Plugin_luVars["prevSpellsFrame"]=HealBot_Plugin_luVars["prevFrame"]
	frame:Show()
	HealBot_Plugin_luVars["prevFrame"]=frame
    if button then
        OptionObjects["OptionSetSpellsFor"]:Show()
        OptionObjects["OptionSetModifierKey"]:Show()
        OptionObjects["OptionButton610Btn"]:Show()
        OptionObjects["OptionButton1115Btn"]:Show()
        OptionObjects["OptionButton1620Btn"]:Show()
        local r,g,b=HealBot_Options_OptionsThemeCols()
        HealBot_Plugin_luVars["prevFrameBtn"]:SetStatusBarColor(r, g, b, 0.5)
        HealBot_Plugin_luVars["prevFrameBtn"].Text:SetTextColor(r, g, b, 0.8)
        button:SetStatusBarColor(r, g, b, 1)
        button.Text:SetTextColor(1, 1, 1, 1)
        HealBot_Plugin_luVars["prevFrameBtn"]=button
    else
        OptionObjects["OptionSetSpellsFor"]:Hide()
        OptionObjects["OptionSetModifierKey"]:Hide()
        OptionObjects["OptionButton610Btn"]:Hide()
        OptionObjects["OptionButton1115Btn"]:Hide()
        OptionObjects["OptionButton1620Btn"]:Hide()
        if HealBot_Plugin_luVars["SetSpellsForListID"]==1 then
            HealBot_Plugin_Options_SetLabel(OptionObjects["OptionsHelpFrameH1"],HEALBOT_OPTIONS_SETSPELLS..": "..HEALBOT_OPTIONS_ENABLEDBARS)
        else
            HealBot_Plugin_Options_SetLabel(OptionObjects["OptionsHelpFrameH1"],HEALBOT_OPTIONS_SETSPELLS..": "..HEALBOT_OPTIONS_ENEMYBARS)
        end
        HealBot_Plugin_Options_SetLabel(OptionObjects["OptionsHelpFrameH2"],HEALBOT_OPTIONS_COMBOCLASS..":  "..HealBot_Options_ComboButton_ModifierKey(HealBot_Plugin_luVars["ModifierKeyListID"]).."-"..HEALBOT_OPTIONS_COMBOBUTTON..HealBot_Plugin_luVars["helpBtn"].." "..HEALBOT_OPTIONS_CLICK)
        HealBot_Plugin_Options_SetHelpSelectValues()
    end
end

local function HealBot_Plugin_Options_SetupStatusBarButton(bar, width, x, text)
	bar:SetSize(width, 22)
	bar:SetPoint("TOP", x, -170)
	bar:SetStatusBarTexture("Interface\\Addons\\HealBot\\Images\\tukuibar.tga")
	bar.Text = bar:CreateFontString()
	bar.Text:SetFontObject(GameFontNormal)
	bar.Text:SetPoint("CENTER")
	bar.Text:SetJustifyH("CENTER")
	bar.Text:SetJustifyV("CENTER")
    bar.Text:SetText(text)
end

local function HealBot_Plugin_Options_SpellsSelect_OnClick(id)
    local hbTmpText1=nil
    if id==1 then
        hbTmpText1=HealBot_Plugin_luVars["hbHelpHealSelect"] or ""
    elseif id==2 then
        hbTmpText1=HealBot_Plugin_luVars["hbHelpOtherSelect"] or ""
    elseif id==3 then
        hbTmpText1=HealBot_Plugin_luVars["hbHelpMacroSelect"] or ""
    elseif id==4 then
        hbTmpText1=HealBot_Plugin_luVars["hbHelpItemSelect"] or ""
    elseif id==5 then
        hbTmpText1=HealBot_Plugin_luVars["hbHelpCmdsSelect"] or ""
    else
        hbTmpText1=HealBot_Plugin_luVars["hbHelpEmotesSelect"]
    end
    if hbTmpText1~=HEALBOT_TOOLTIP_NONE then
        OptionObjects["OptionEditBox"..HealBot_Plugin_luVars["helpBtn"]]:SetText(hbTmpText1)
    end
end

local function HealBot_Plugin_Options_SetupHelpSelectButton(id)
    local parent=OptionObjects["OptionFrame610"]
    local alias="OptionHelpBtn"..id
    if id>15 then
        parent=OptionObjects["OptionFrame1620"]
    elseif id>10 then 
        parent=OptionObjects["OptionFrame1115"] 
    end
    OptionObjects[alias] = CreateFrame("Button", "HealBot_"..HealBot_Plugin_luVars["pluginId"].."_HelpSelect"..id, parent, "UIPanelButtonTemplate")
    
    OptionObjects[alias]:SetPoint("LEFT", OptionObjects["OptionEditBox"..id], "RIGHT", 10, 0)
	OptionObjects[alias]:SetWidth(22)
	OptionObjects[alias]:SetHeight(19)
	
	OptionObjects[alias]:SetNormalFontObject("GameFontNormal")
	OptionObjects[alias]:SetText("?")

    OptionObjects[alias]:SetScript("OnMouseDown", function() HealBot_Plugin_luVars["helpBtn"]=id; HealBot_Plugin_Frame_OnClick(OptionObjects["OptionFrameSpellsSelect"]); end)
end

local function HealBot_Plugin_Options_SetupHelpFrameButton(id)
    local alias="OptionHelpSelectBtn"..id
    OptionObjects[alias] = CreateFrame("Button", "HealBot_"..HealBot_Plugin_luVars["pluginId"].."_HelpSelectBtn"..id, OptionObjects["OptionFrameSpellsSelect"], "UIPanelButtonTemplate")
    
    OptionObjects[alias]:SetPoint("LEFT", OptionObjects["OptionsHelpDropdown"..id], "RIGHT", 10, 2)
	OptionObjects[alias]:SetWidth(140)
	OptionObjects[alias]:SetHeight(25)
	
	OptionObjects[alias]:SetNormalFontObject("GameFontNormal")
	OptionObjects[alias]:SetText(HEALBOT_WORD_SELECT)

    OptionObjects[alias]:SetScript("OnMouseDown", function() HealBot_Plugin_Options_SpellsSelect_OnClick(id); HealBot_Plugin_Frame_OnClick(HealBot_Plugin_luVars["prevSpellsFrame"],HealBot_Plugin_luVars["prevFrameBtn"]); end)
end

local spellText=nil
local function HealBot_Plugin_SpellsOnTextChanged(self, bNo)
    local cType="ENEMY"
    if HealBot_Plugin_luVars["SetSpellsForListID"]==1 then
        cType="ENABLED"
    end
    local key=HealBot_Options_ComboButton_ModifierKey(HealBot_Plugin_luVars["ModifierKeyListID"])
    spellText = strtrim(self:GetText())
    HealBot_Options_DoSpellsOnTextChanged(self, cType, bNo, key, spellText)
    HealBot_Plugin_Options_PrepAttribs()
end

local function HealBot_Plugin_SpellAutoButton_OnClick(self, autoType, autoButton)
    if self:GetChecked() then
        HealBot_SpellAutoButton_Update(autoType, HealBot_Options_ComboButton_ModifierKey(HealBot_Plugin_luVars["ModifierKeyListID"]), HealBot_Plugin_luVars["SetSpellsForListID"], autoButton, "true")
    else
        HealBot_SpellAutoButton_Update(autoType, HealBot_Options_ComboButton_ModifierKey(HealBot_Plugin_luVars["ModifierKeyListID"]), HealBot_Plugin_luVars["SetSpellsForListID"], autoButton, "false")
    end
    HealBot_Timers_PluginsSet(3)
end

local function HealBot_Plugin_Options_SetValues()
    local combo=nil
    local cType=nil
    local modifier=HealBot_Options_ComboButton_ModifierKey(HealBot_Plugin_luVars["ModifierKeyListID"])
    HealBot_Action_ClearSpellCache()
    if HealBot_Plugin_luVars["SetSpellsForListID"]==1 then
        cType="ENABLED"
    else
        cType="ENEMY"
    end
    OptionObjects["OptionEditBox6"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(6))) or "")
    OptionObjects["OptionEditBox7"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(7))) or "")
    OptionObjects["OptionEditBox8"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(8))) or "")
    OptionObjects["OptionEditBox9"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(9))) or "")
    OptionObjects["OptionEditBox10"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(10))) or "")
    OptionObjects["OptionEditBox11"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(11))) or "")
    OptionObjects["OptionEditBox12"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(12))) or "")
    OptionObjects["OptionEditBox13"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(13))) or "")
    OptionObjects["OptionEditBox14"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(14))) or "")
    OptionObjects["OptionEditBox15"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(15))) or "")
    OptionObjects["OptionEditBox16"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(16))) or "")
    OptionObjects["OptionEditBox17"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(17))) or "")
    OptionObjects["OptionEditBox18"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(18))) or "")
    OptionObjects["OptionEditBox19"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(19))) or "")
    OptionObjects["OptionEditBox20"]:SetText(HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(20))) or "")


    if HealBot_Plugin_luVars["SetSpellsForListID"]==1 then
        combo = HealBot_Config_Spells.EnabledSpellTarget;
    else
        combo = HealBot_Config_Spells.EnemySpellTarget;
    end
    if combo then
        OptionObjects["OptionTarget6"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(6))] or false)
        OptionObjects["OptionTarget7"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(7))] or false)
        OptionObjects["OptionTarget8"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(8))] or false)
        OptionObjects["OptionTarget9"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(9))] or false)
        OptionObjects["OptionTarget10"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(10))] or false)
        OptionObjects["OptionTarget11"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(11))] or false)
        OptionObjects["OptionTarget12"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(12))] or false)
        OptionObjects["OptionTarget13"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(13))] or false)
        OptionObjects["OptionTarget14"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(14))] or false)
        OptionObjects["OptionTarget15"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(15))] or false)
        OptionObjects["OptionTarget16"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(16))] or false)
        OptionObjects["OptionTarget17"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(17))] or false)
        OptionObjects["OptionTarget18"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(18))] or false)
        OptionObjects["OptionTarget19"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(19))] or false)
        OptionObjects["OptionTarget20"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(20))] or false)
    end
    if HealBot_Plugin_luVars["SetSpellsForListID"]==1 then
        combo = HealBot_Config_Spells.EnabledSpellTrinket1;
    else
        combo = HealBot_Config_Spells.EnemySpellTrinket1;
    end
    if combo then
        OptionObjects["OptionTrinketA6"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(6))] or false)
        OptionObjects["OptionTrinketA7"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(7))] or false)
        OptionObjects["OptionTrinketA8"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(8))] or false)
        OptionObjects["OptionTrinketA9"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(9))] or false)
        OptionObjects["OptionTrinketA10"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(10))] or false)
        OptionObjects["OptionTrinketA11"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(11))] or false)
        OptionObjects["OptionTrinketA12"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(12))] or false)
        OptionObjects["OptionTrinketA13"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(13))] or false)
        OptionObjects["OptionTrinketA14"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(14))] or false)
        OptionObjects["OptionTrinketA15"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(15))] or false)
        OptionObjects["OptionTrinketA16"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(16))] or false)
        OptionObjects["OptionTrinketA17"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(17))] or false)
        OptionObjects["OptionTrinketA18"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(18))] or false)
        OptionObjects["OptionTrinketA19"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(19))] or false)
        OptionObjects["OptionTrinketA20"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(20))] or false)
    end
    if HealBot_Plugin_luVars["SetSpellsForListID"]==1 then
        combo = HealBot_Config_Spells.EnabledSpellTrinket2;
    else
        combo = HealBot_Config_Spells.EnemySpellTrinket2;
    end
    if combo then
        OptionObjects["OptionTrinketB6"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(6))] or false)
        OptionObjects["OptionTrinketB7"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(7))] or false)
        OptionObjects["OptionTrinketB8"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(8))] or false)
        OptionObjects["OptionTrinketB9"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(9))] or false)
        OptionObjects["OptionTrinketB10"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(10))] or false)
        OptionObjects["OptionTrinketB11"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(11))] or false)
        OptionObjects["OptionTrinketB12"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(12))] or false)
        OptionObjects["OptionTrinketB13"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(13))] or false)
        OptionObjects["OptionTrinketB14"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(14))] or false)
        OptionObjects["OptionTrinketB15"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(15))] or false)
        OptionObjects["OptionTrinketB16"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(16))] or false)
        OptionObjects["OptionTrinketB17"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(17))] or false)
        OptionObjects["OptionTrinketB18"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(18))] or false)
        OptionObjects["OptionTrinketB19"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(19))] or false)
        OptionObjects["OptionTrinketB20"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(20))] or false)
    end
    if HealBot_Plugin_luVars["SetSpellsForListID"]==1 then
        combo = HealBot_Config_Spells.EnabledAvoidBlueCursor;
    else
        combo = HealBot_Config_Spells.EnemyAvoidBlueCursor;
    end
    if combo then
        OptionObjects["OptionAvoid6"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(6))] or false)
        OptionObjects["OptionAvoid7"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(7))] or false)
        OptionObjects["OptionAvoid8"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(8))] or false)
        OptionObjects["OptionAvoid9"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(9))] or false)
        OptionObjects["OptionAvoid10"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(10))] or false)
        OptionObjects["OptionAvoid11"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(11))] or false)
        OptionObjects["OptionAvoid12"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(12))] or false)
        OptionObjects["OptionAvoid13"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(13))] or false)
        OptionObjects["OptionAvoid14"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(14))] or false)
        OptionObjects["OptionAvoid15"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(15))] or false)
        OptionObjects["OptionAvoid16"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(16))] or false)
        OptionObjects["OptionAvoid17"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(17))] or false)
        OptionObjects["OptionAvoid18"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(18))] or false)
        OptionObjects["OptionAvoid19"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(19))] or false)
        OptionObjects["OptionAvoid20"]:SetChecked(combo[HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(20))] or false)
    end
end

local function HealBot_Plugin_Options()
	local pId=HealBot_Plugin_luVars["pluginId"]
	if not HealBot_Plugin_luVars["optionsInit"] then
        local modifier=HealBot_Options_ComboButton_ModifierKey(HealBot_Plugin_luVars["ModifierKeyListID"])
        local cType="ENEMY"
        HealBot_Action_ClearSpellCache()
        if HealBot_Plugin_luVars["SetSpellsForListID"]==1 then
            cType="ENABLED"
        end
        
		OptionObjects["OptionSetSpellsFor"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_SetSpellsFor", HealBot_Plugin_luVars["OptionsFrame"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionSetSpellsFor"], 240, -150, -120, HEALBOT_OPTIONS_SETSPELLS)
		OptionObjects["OptionSetModifierKey"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_ModifierKey", HealBot_Plugin_luVars["OptionsFrame"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionSetModifierKey"], 240, 150, -120, HEALBOT_OPTIONS_MODIFIER)
        UIDropDownMenu_Initialize(OptionObjects["OptionSetSpellsFor"], OptionSetSpellsFor_DropDown)
        UIDropDownMenu_Initialize(OptionObjects["OptionSetModifierKey"], OptionSetModifierKey_DropDown)

		OptionObjects["OptionButton610Btn"] = CreateFrame("StatusBar", "HealBot_"..pId.."_B610_Button", HealBot_Plugin_luVars["OptionsFrame"])
		HealBot_Plugin_Options_SetupStatusBarButton(OptionObjects["OptionButton610Btn"], 170, -190, HEALBOT_PLUGIN_EXTRABUTTONS_0610, true)
		OptionObjects["OptionButton610Btn"]:SetScript("OnMouseDown", function() HealBot_Plugin_Frame_OnClick(OptionObjects["OptionFrame610"], OptionObjects["OptionButton610Btn"]); end)
		OptionObjects["OptionButton1115Btn"] = CreateFrame("StatusBar", "HealBot_"..pId.."_B1115_Button", HealBot_Plugin_luVars["OptionsFrame"])
		HealBot_Plugin_Options_SetupStatusBarButton(OptionObjects["OptionButton1115Btn"], 170, 0, HEALBOT_PLUGIN_EXTRABUTTONS_1115)
		OptionObjects["OptionButton1115Btn"]:SetScript("OnMouseDown", function() HealBot_Plugin_Frame_OnClick(OptionObjects["OptionFrame1115"], OptionObjects["OptionButton1115Btn"]); end)
		OptionObjects["OptionButton1620Btn"] = CreateFrame("StatusBar", "HealBot_"..pId.."_B1620_Button", HealBot_Plugin_luVars["OptionsFrame"])
		HealBot_Plugin_Options_SetupStatusBarButton(OptionObjects["OptionButton1620Btn"], 170, 190, HEALBOT_PLUGIN_EXTRABUTTONS_1620)
		OptionObjects["OptionButton1620Btn"]:SetScript("OnMouseDown", function() HealBot_Plugin_Frame_OnClick(OptionObjects["OptionFrame1620"], OptionObjects["OptionButton1620Btn"]); end)
		HealBot_Plugin_luVars["prevFrameBtn"]=OptionObjects["OptionButton610Btn"]
        
		OptionObjects["OptionFrame610"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_Frame610", HealBot_Plugin_luVars["OptionsFrame"], BackdropTemplateMixin and "BackdropTemplate")
		HealBot_Plugin_Options_SetupFrame(OptionObjects["OptionFrame610"])
		OptionObjects["OptionFrame1115"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_Frame1115", HealBot_Plugin_luVars["OptionsFrame"], BackdropTemplateMixin and "BackdropTemplate")
		HealBot_Plugin_Options_SetupFrame(OptionObjects["OptionFrame1115"], true)
		OptionObjects["OptionFrame1620"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_Frame1620", HealBot_Plugin_luVars["OptionsFrame"], BackdropTemplateMixin and "BackdropTemplate")
		HealBot_Plugin_Options_SetupFrame(OptionObjects["OptionFrame1620"], true)
		OptionObjects["OptionFrameSpellsSelect"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_SpellsSelect", HealBot_Plugin_luVars["OptionsFrame"], BackdropTemplateMixin and "BackdropTemplate")
		HealBot_Plugin_Options_SetupFrame(OptionObjects["OptionFrameSpellsSelect"], true)
        
		-- Buttons 6 - 10

		OptionObjects["OptionEditBox6"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox6", OptionObjects["OptionFrame610"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox6"],OptionObjects["OptionFrame610"], -55, -45, HEALBOT_OPTIONS_BUTTON6, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(6))) or "")
		OptionObjects["OptionEditBox6"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox6"], 6); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(6)
        
		OptionObjects["OptionAvoid6"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid6", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid6"]:SetPoint("TOPLEFT", 42, -45)
		OptionObjects["OptionAvoid6"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid6"], "AvoidBC", 6); end)
        
		OptionObjects["OptionTarget6"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target6", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget6"]:SetPoint("TOPLEFT", 112, -45)
		OptionObjects["OptionTarget6"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget6"], "Target", 6); end)
        
		OptionObjects["OptionTrinketA6"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA6", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA6"]:SetPoint("TOPLEFT", 388, -45)
		OptionObjects["OptionTrinketA6"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA6"], "Trinket1", 6); end)
        
		OptionObjects["OptionTrinketB6"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB6", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB6"]:SetPoint("TOPLEFT", 418, -45)
		OptionObjects["OptionTrinketB6"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB6"], "Trinket2", 6); end)

		OptionObjects["OptionBindsB6"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds6", OptionObjects["OptionFrame610"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB6"], 100, 220, -42, "")


		OptionObjects["OptionEditBox7"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox7", OptionObjects["OptionFrame610"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox7"],OptionObjects["OptionFrame610"], -55, -110, HEALBOT_OPTIONS_BUTTON7, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(7))) or "")
		OptionObjects["OptionEditBox7"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox7"], 7); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(7)
        
		OptionObjects["OptionAvoid7"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid7", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid7"]:SetPoint("TOPLEFT", 42, -110)
		OptionObjects["OptionAvoid7"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid7"], "AvoidBC", 7); end)
        
		OptionObjects["OptionTarget7"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target7", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget7"]:SetPoint("TOPLEFT", 112, -110)
		OptionObjects["OptionTarget7"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget7"], "Target", 7); end)
        
		OptionObjects["OptionTrinketA7"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA7", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA7"]:SetPoint("TOPLEFT", 388, -110)
		OptionObjects["OptionTrinketA7"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA7"], "Trinket1", 7); end)
        
		OptionObjects["OptionTrinketB7"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB7", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB7"]:SetPoint("TOPLEFT", 418, -110)
		OptionObjects["OptionTrinketB7"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB7"], "Trinket2", 7); end)

		OptionObjects["OptionBindsB7"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds7", OptionObjects["OptionFrame610"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB7"], 100, 220, -107, "")


		OptionObjects["OptionEditBox8"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox8", OptionObjects["OptionFrame610"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox8"],OptionObjects["OptionFrame610"], -55, -175, HEALBOT_OPTIONS_BUTTON8, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(8))) or "")
		OptionObjects["OptionEditBox8"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox8"], 8); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(8)
        
		OptionObjects["OptionAvoid8"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid8", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid8"]:SetPoint("TOPLEFT", 42, -175)
		OptionObjects["OptionAvoid8"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid8"], "AvoidBC", 8); end)
        
		OptionObjects["OptionTarget8"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target8", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget8"]:SetPoint("TOPLEFT", 112, -175)
		OptionObjects["OptionTarget8"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget8"], "Target", 8); end)
        
		OptionObjects["OptionTrinketA8"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA8", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA8"]:SetPoint("TOPLEFT", 388, -175)
		OptionObjects["OptionTrinketA8"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA8"], "Trinket1", 8); end)
        
		OptionObjects["OptionTrinketB8"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB8", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB8"]:SetPoint("TOPLEFT", 418, -175)
		OptionObjects["OptionTrinketB8"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB8"], "Trinket2", 8); end)

		OptionObjects["OptionBindsB8"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds8", OptionObjects["OptionFrame610"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB8"], 100, 220, -172, "")


		OptionObjects["OptionEditBox9"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox9", OptionObjects["OptionFrame610"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox9"],OptionObjects["OptionFrame610"], -55, -240, HEALBOT_OPTIONS_BUTTON9, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(9))) or "")
		OptionObjects["OptionEditBox9"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox9"], 9); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(9)
        
		OptionObjects["OptionAvoid9"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid9", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid9"]:SetPoint("TOPLEFT", 42, -240)
		OptionObjects["OptionAvoid9"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid9"], "AvoidBC", 9); end)
        
		OptionObjects["OptionTarget9"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target9", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget9"]:SetPoint("TOPLEFT", 112, -240)
		OptionObjects["OptionTarget9"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget9"], "Target", 9); end)
        
		OptionObjects["OptionTrinketA9"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA9", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA9"]:SetPoint("TOPLEFT", 388, -240)
		OptionObjects["OptionTrinketA9"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA9"], "Trinket1", 9); end)
        
		OptionObjects["OptionTrinketB9"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB9", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB9"]:SetPoint("TOPLEFT", 418, -240)
		OptionObjects["OptionTrinketB9"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB9"], "Trinket2", 9); end)

		OptionObjects["OptionBindsB9"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds9", OptionObjects["OptionFrame610"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB9"], 100, 220, -237, "")


		OptionObjects["OptionEditBox10"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox10", OptionObjects["OptionFrame610"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox10"],OptionObjects["OptionFrame610"], -55, -305, HEALBOT_OPTIONS_BUTTON10, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(10))) or "")
		OptionObjects["OptionEditBox10"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox10"], 10); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(10)
        
		OptionObjects["OptionAvoid10"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid10", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid10"]:SetPoint("TOPLEFT", 42, -305)
		OptionObjects["OptionAvoid10"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid10"], "AvoidBC", 10); end)
        
		OptionObjects["OptionTarget10"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target10", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget10"]:SetPoint("TOPLEFT", 112, -305)
		OptionObjects["OptionTarget10"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget10"], "Target", 10); end)
        
		OptionObjects["OptionTrinketA10"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA10", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA10"]:SetPoint("TOPLEFT", 388, -305)
		OptionObjects["OptionTrinketA10"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA10"], "Trinket1", 10); end)
        
		OptionObjects["OptionTrinketB10"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB10", OptionObjects["OptionFrame610"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB10"]:SetPoint("TOPLEFT", 418, -305)
		OptionObjects["OptionTrinketB10"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB10"], "Trinket2", 10); end)

		OptionObjects["OptionBindsB10"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds10", OptionObjects["OptionFrame610"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB10"], 100, 220, -302, "")

		-- Buttons 11 - 15
        
		OptionObjects["OptionEditBox11"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox11", OptionObjects["OptionFrame1115"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox11"],OptionObjects["OptionFrame1115"], -55, -45, HEALBOT_OPTIONS_BUTTON11, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(11))) or "")
		OptionObjects["OptionEditBox11"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox11"], 11); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(11)
        
		OptionObjects["OptionAvoid11"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid11", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid11"]:SetPoint("TOPLEFT", 42, -45)
		OptionObjects["OptionAvoid11"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid11"], "AvoidBC", 11); end)
        
		OptionObjects["OptionTarget11"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target11", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget11"]:SetPoint("TOPLEFT", 112, -45)
		OptionObjects["OptionTarget11"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget11"], "Target", 11); end)
        
		OptionObjects["OptionTrinketA11"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA11", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA11"]:SetPoint("TOPLEFT", 388, -45)
		OptionObjects["OptionTrinketA11"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA11"], "Trinket1", 11); end)
        
		OptionObjects["OptionTrinketB11"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB11", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB11"]:SetPoint("TOPLEFT", 418, -45)
		OptionObjects["OptionTrinketB11"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB11"], "Trinket2", 11); end)

		OptionObjects["OptionBindsB11"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds11", OptionObjects["OptionFrame1115"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB11"], 100, 220, -42, "")


		OptionObjects["OptionEditBox12"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox12", OptionObjects["OptionFrame1115"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox12"],OptionObjects["OptionFrame1115"], -55, -110, HEALBOT_OPTIONS_BUTTON12, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(12))) or "")
		OptionObjects["OptionEditBox12"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox12"], 12); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(12)
        
		OptionObjects["OptionAvoid12"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid12", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid12"]:SetPoint("TOPLEFT", 42, -110)
		OptionObjects["OptionAvoid12"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid12"], "AvoidBC", 12); end)
        
		OptionObjects["OptionTarget12"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target12", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget12"]:SetPoint("TOPLEFT", 112, -110)
		OptionObjects["OptionTarget12"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget12"], "Target", 12); end)
        
		OptionObjects["OptionTrinketA12"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA12", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA12"]:SetPoint("TOPLEFT", 388, -110)
		OptionObjects["OptionTrinketA12"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA12"], "Trinket1", 12); end)
        
		OptionObjects["OptionTrinketB12"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB12", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB12"]:SetPoint("TOPLEFT", 418, -110)
		OptionObjects["OptionTrinketB12"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB12"], "Trinket2", 12); end)

		OptionObjects["OptionBindsB12"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds12", OptionObjects["OptionFrame1115"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB12"], 100, 220, -107, "")


		OptionObjects["OptionEditBox13"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox13", OptionObjects["OptionFrame1115"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox13"],OptionObjects["OptionFrame1115"], -55, -175, HEALBOT_OPTIONS_BUTTON13, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(13))) or "")
		OptionObjects["OptionEditBox13"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox13"], 13); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(13)
        
		OptionObjects["OptionAvoid13"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid13", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid13"]:SetPoint("TOPLEFT", 42, -175)
		OptionObjects["OptionAvoid13"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid13"], "AvoidBC", 13); end)
        
		OptionObjects["OptionTarget13"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target13", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget13"]:SetPoint("TOPLEFT", 112, -175)
		OptionObjects["OptionTarget13"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget13"], "Target", 13); end)
        
		OptionObjects["OptionTrinketA13"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA13", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA13"]:SetPoint("TOPLEFT", 388, -175)
		OptionObjects["OptionTrinketA13"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA13"], "Trinket1", 13); end)
        
		OptionObjects["OptionTrinketB13"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB13", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB13"]:SetPoint("TOPLEFT", 418, -175)
		OptionObjects["OptionTrinketB13"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB13"], "Trinket2", 13); end)

		OptionObjects["OptionBindsB13"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds13", OptionObjects["OptionFrame1115"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB13"], 100, 220, -172, "")


		OptionObjects["OptionEditBox14"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox14", OptionObjects["OptionFrame1115"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox14"],OptionObjects["OptionFrame1115"], -55, -240, HEALBOT_OPTIONS_BUTTON14, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(14))) or "")
		OptionObjects["OptionEditBox14"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox14"], 14); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(14)
        
		OptionObjects["OptionAvoid14"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid14", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid14"]:SetPoint("TOPLEFT", 42, -240)
		OptionObjects["OptionAvoid14"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid14"], "AvoidBC", 14); end)
        
		OptionObjects["OptionTarget14"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target14", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget14"]:SetPoint("TOPLEFT", 112, -240)
		OptionObjects["OptionTarget14"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget14"], "Target", 14); end)
        
		OptionObjects["OptionTrinketA14"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA14", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA14"]:SetPoint("TOPLEFT", 388, -240)
		OptionObjects["OptionTrinketA14"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA14"], "Trinket1", 14); end)
        
		OptionObjects["OptionTrinketB14"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB14", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB14"]:SetPoint("TOPLEFT", 418, -240)
		OptionObjects["OptionTrinketB14"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB14"], "Trinket2", 14); end)

		OptionObjects["OptionBindsB14"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds14", OptionObjects["OptionFrame1115"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB14"], 100, 220, -237, "")


		OptionObjects["OptionEditBox15"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox15", OptionObjects["OptionFrame1115"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox15"],OptionObjects["OptionFrame1115"], -55, -305, HEALBOT_OPTIONS_BUTTON15, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(15))) or "")
		OptionObjects["OptionEditBox15"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox15"], 15); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(15)
        
		OptionObjects["OptionAvoid15"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid15", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid15"]:SetPoint("TOPLEFT", 42, -305)
		OptionObjects["OptionAvoid15"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid15"], "AvoidBC", 15); end)
        
		OptionObjects["OptionTarget15"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target15", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget15"]:SetPoint("TOPLEFT", 112, -305)
		OptionObjects["OptionTarget15"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget15"], "Target", 15); end)
        
		OptionObjects["OptionTrinketA15"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA15", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA15"]:SetPoint("TOPLEFT", 388, -305)
		OptionObjects["OptionTrinketA15"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA15"], "Trinket1", 15); end)
        
		OptionObjects["OptionTrinketB15"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB15", OptionObjects["OptionFrame1115"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB15"]:SetPoint("TOPLEFT", 418, -305)
		OptionObjects["OptionTrinketB15"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB15"], "Trinket2", 15); end)

		OptionObjects["OptionBindsB15"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds15", OptionObjects["OptionFrame1115"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB15"], 100, 220, -302, "")

		-- Buttons 11 - 15
        
		OptionObjects["OptionEditBox16"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox16", OptionObjects["OptionFrame1620"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox16"],OptionObjects["OptionFrame1620"], -55, -45, HEALBOT_OPTIONS_BUTTON16, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(16))) or "")
		OptionObjects["OptionEditBox16"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox16"], 16); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(16)
        
		OptionObjects["OptionAvoid16"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid16", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid16"]:SetPoint("TOPLEFT", 42, -45)
		OptionObjects["OptionAvoid16"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid16"], "AvoidBC", 16); end)
        
		OptionObjects["OptionTarget16"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target16", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget16"]:SetPoint("TOPLEFT", 112, -45)
		OptionObjects["OptionTarget16"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget16"], "Target", 16); end)
        
		OptionObjects["OptionTrinketA16"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA16", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA16"]:SetPoint("TOPLEFT", 388, -45)
		OptionObjects["OptionTrinketA16"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA16"], "Trinket1", 16); end)
        
		OptionObjects["OptionTrinketB16"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB16", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB16"]:SetPoint("TOPLEFT", 418, -45)
		OptionObjects["OptionTrinketB16"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB16"], "Trinket2", 16); end)

		OptionObjects["OptionBindsB16"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds16", OptionObjects["OptionFrame1620"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB16"], 100, 220, -42, "")


		OptionObjects["OptionEditBox17"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox17", OptionObjects["OptionFrame1620"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox17"],OptionObjects["OptionFrame1620"], -55, -110, HEALBOT_OPTIONS_BUTTON17, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(17))) or "")
		OptionObjects["OptionEditBox17"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox17"], 17); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(17)
        
		OptionObjects["OptionAvoid17"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid17", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid17"]:SetPoint("TOPLEFT", 42, -110)
		OptionObjects["OptionAvoid17"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid17"], "AvoidBC", 17); end)
        
		OptionObjects["OptionTarget17"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target17", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget17"]:SetPoint("TOPLEFT", 112, -110)
		OptionObjects["OptionTarget17"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget17"], "Target", 17); end)
        
		OptionObjects["OptionTrinketA17"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA17", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA17"]:SetPoint("TOPLEFT", 388, -110)
		OptionObjects["OptionTrinketA17"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA17"], "Trinket1", 17); end)
        
		OptionObjects["OptionTrinketB17"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB17", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB17"]:SetPoint("TOPLEFT", 418, -110)
		OptionObjects["OptionTrinketB17"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB17"], "Trinket2", 17); end)

		OptionObjects["OptionBindsB17"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds17", OptionObjects["OptionFrame1620"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB17"], 100, 220, -107, "")


		OptionObjects["OptionEditBox18"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox18", OptionObjects["OptionFrame1620"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox18"],OptionObjects["OptionFrame1620"], -55, -175, HEALBOT_OPTIONS_BUTTON18, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(18))) or "")
		OptionObjects["OptionEditBox18"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox18"], 18); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(18)
        
		OptionObjects["OptionAvoid18"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid18", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid18"]:SetPoint("TOPLEFT", 42, -175)
		OptionObjects["OptionAvoid18"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid18"], "AvoidBC", 18); end)
        
		OptionObjects["OptionTarget18"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target18", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget18"]:SetPoint("TOPLEFT", 112, -175)
		OptionObjects["OptionTarget18"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget18"], "Target", 18); end)
        
		OptionObjects["OptionTrinketA18"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA18", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA18"]:SetPoint("TOPLEFT", 388, -175)
		OptionObjects["OptionTrinketA18"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA18"], "Trinket1", 18); end)
        
		OptionObjects["OptionTrinketB18"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB18", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB18"]:SetPoint("TOPLEFT", 418, -175)
		OptionObjects["OptionTrinketB18"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB18"], "Trinket2", 18); end)

		OptionObjects["OptionBindsB18"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds18", OptionObjects["OptionFrame1620"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB18"], 100, 220, -172, "")


		OptionObjects["OptionEditBox19"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox19", OptionObjects["OptionFrame1620"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox19"],OptionObjects["OptionFrame1620"], -55, -240, HEALBOT_OPTIONS_BUTTON19, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(19))) or "")
		OptionObjects["OptionEditBox19"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox19"], 19); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(19)
        
		OptionObjects["OptionAvoid19"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid19", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid19"]:SetPoint("TOPLEFT", 42, -240)
		OptionObjects["OptionAvoid19"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid19"], "AvoidBC", 19); end)
        
		OptionObjects["OptionTarget19"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target19", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget19"]:SetPoint("TOPLEFT", 112, -240)
		OptionObjects["OptionTarget19"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget19"], "Target", 19); end)
        
		OptionObjects["OptionTrinketA19"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA19", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA19"]:SetPoint("TOPLEFT", 388, -240)
		OptionObjects["OptionTrinketA19"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA19"], "Trinket1", 19); end)
        
		OptionObjects["OptionTrinketB19"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB19", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB19"]:SetPoint("TOPLEFT", 418, -240)
		OptionObjects["OptionTrinketB19"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB19"], "Trinket2", 19); end)

		OptionObjects["OptionBindsB19"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds19", OptionObjects["OptionFrame1620"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB19"], 100, 220, -237, "")


		OptionObjects["OptionEditBox20"] = CreateFrame("EditBox", "HealBot_"..pId.."_EditBox20", OptionObjects["OptionFrame1620"], "HealBot_Options_EditBoxTemplate")
		HealBot_Plugin_Options_Setup_EditBox(OptionObjects["OptionEditBox20"],OptionObjects["OptionFrame1620"], -55, -305, HEALBOT_OPTIONS_BUTTON20, HealBot_Action_GetSpell(cType, HealBot_Action_GetComboSpec(modifier, HealBot_Options_ComboClass_Button(20))) or "")
		OptionObjects["OptionEditBox20"]:SetScript("OnTextChanged", function() HealBot_Plugin_SpellsOnTextChanged(OptionObjects["OptionEditBox20"], 20); end)
		HealBot_Plugin_Options_SetupHelpSelectButton(20)
        
		OptionObjects["OptionAvoid20"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Avoid20", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionAvoid20"]:SetPoint("TOPLEFT", 42, -305)
		OptionObjects["OptionAvoid20"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionAvoid20"], "AvoidBC", 20); end)
        
		OptionObjects["OptionTarget20"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Target20", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTarget20"]:SetPoint("TOPLEFT", 112, -305)
		OptionObjects["OptionTarget20"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTarget20"], "Target", 20); end)
        
		OptionObjects["OptionTrinketA20"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketA20", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketA20"]:SetPoint("TOPLEFT", 388, -305)
		OptionObjects["OptionTrinketA20"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketA20"], "Trinket1", 20); end)
        
		OptionObjects["OptionTrinketB20"] = CreateFrame("CheckButton", "HealBot_"..pId.."_TrinketB20", OptionObjects["OptionFrame1620"], "SendMailRadioButtonTemplate")
		OptionObjects["OptionTrinketB20"]:SetPoint("TOPLEFT", 418, -305)
		OptionObjects["OptionTrinketB20"]:SetScript("OnClick", function() HealBot_Plugin_SpellAutoButton_OnClick(OptionObjects["OptionTrinketB20"], "Trinket2", 20); end)

		OptionObjects["OptionBindsB20"] = CreateFrame("Frame", "HealBot_"..pId.."_Binds20", OptionObjects["OptionFrame1620"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionBindsB20"], 100, 220, -302, "")

		-- Help Select frame
        
        OptionObjects["OptionsHelpFrameH1"]=OptionObjects["OptionFrameSpellsSelect"]:CreateFontString("HealBot_"..pId.."_HelpTextH1","OVERLAY","GameFontNormal")
        OptionObjects["OptionsHelpFrameH1"]:SetPoint("TOP", 0, 50)
        OptionObjects["OptionsHelpFrameH2"]=OptionObjects["OptionFrameSpellsSelect"]:CreateFontString("HealBot_"..pId.."_HelpTextH2","OVERLAY","GameFontNormal")
        OptionObjects["OptionsHelpFrameH2"]:SetPoint("TOP", 0, 25)

		OptionObjects["OptionsHelpDropdown1"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_HelpHeals1", OptionObjects["OptionFrameSpellsSelect"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionsHelpDropdown1"], 240, -80, -30, "")
		HealBot_Plugin_Options_SetupHelpFrameButton(1)

		OptionObjects["OptionsHelpDropdown2"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_HelpHeals2", OptionObjects["OptionFrameSpellsSelect"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionsHelpDropdown2"], 240, -80, -80, "")
		HealBot_Plugin_Options_SetupHelpFrameButton(2)

		OptionObjects["OptionsHelpDropdown3"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_HelpHeals3", OptionObjects["OptionFrameSpellsSelect"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionsHelpDropdown3"], 240, -80, -130, "")
		HealBot_Plugin_Options_SetupHelpFrameButton(3)

		OptionObjects["OptionsHelpDropdown4"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_HelpHeals4", OptionObjects["OptionFrameSpellsSelect"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionsHelpDropdown4"], 240, -80, -180, "")
		HealBot_Plugin_Options_SetupHelpFrameButton(4)

		OptionObjects["OptionsHelpDropdown5"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_HelpHeals5", OptionObjects["OptionFrameSpellsSelect"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionsHelpDropdown5"], 240, -80, -230, "")
		HealBot_Plugin_Options_SetupHelpFrameButton(5)

		OptionObjects["OptionsHelpDropdown6"] = CreateFrame("Frame", "HealBot_"..pId.."_Options_HelpHeals6", OptionObjects["OptionFrameSpellsSelect"], "UIDropDownMenuTemplate")
		HealBot_Plugin_Options_SetupDropDown(OptionObjects["OptionsHelpDropdown6"], 240, -80, -280, "")
		HealBot_Plugin_Options_SetupHelpFrameButton(6)

        OptionObjects["OptionHelpCancelBtn"] = CreateFrame("Button", "HealBot_"..HealBot_Plugin_luVars["pluginId"].."_HelpCancelBtn", OptionObjects["OptionFrameSpellsSelect"], "UIPanelButtonTemplate")
        OptionObjects["OptionHelpCancelBtn"]:SetPoint("BOTTOM", 0, 20)
        OptionObjects["OptionHelpCancelBtn"]:SetWidth(180)
        OptionObjects["OptionHelpCancelBtn"]:SetHeight(25)
        OptionObjects["OptionHelpCancelBtn"]:SetNormalFontObject("GameFontNormal")
        OptionObjects["OptionHelpCancelBtn"]:SetText(HEALBOT_WORD_CANCEL)
        OptionObjects["OptionHelpCancelBtn"]:SetScript("OnMouseDown", function() HealBot_Plugin_Frame_OnClick(HealBot_Plugin_luVars["prevSpellsFrame"],HealBot_Plugin_luVars["prevFrameBtn"]); end)

		HealBot_Plugin_luVars["optionsInit"]=true
	end
	local r,g,b=HealBot_Options_OptionsThemeCols()
	HealBot_Options_SetText(OptionObjects["OptionUse"], " Enable Plugin")
	OptionObjects["OptionFrame1620"]:SetBackdropBorderColor(r,g,b,0.7)
	OptionObjects["OptionFrame1115"]:SetBackdropBorderColor(r,g,b,0.7)
	OptionObjects["OptionFrame610"]:SetBackdropBorderColor(r,g,b,0.7)
	OptionObjects["OptionButton610Btn"]:SetStatusBarColor(r, g, b, 0.5)
	OptionObjects["OptionButton610Btn"].Text:SetTextColor(r, g, b, 0.8)
	OptionObjects["OptionButton1115Btn"]:SetStatusBarColor(r, g, b, 0.5)
	OptionObjects["OptionButton1115Btn"].Text:SetTextColor(r, g, b, 0.8)
	OptionObjects["OptionButton1620Btn"]:SetStatusBarColor(r, g, b, 0.5)
	OptionObjects["OptionButton1620Btn"].Text:SetTextColor(r, g, b, 0.8)
	HealBot_Plugin_luVars["prevFrameBtn"]:SetStatusBarColor(r, g, b, 1)
	HealBot_Plugin_luVars["prevFrameBtn"].Text:SetTextColor(1, 1, 1, 1)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox6"].Txt, HEALBOT_OPTIONS_BUTTON6)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox7"].Txt, HEALBOT_OPTIONS_BUTTON7)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox8"].Txt, HEALBOT_OPTIONS_BUTTON8)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox9"].Txt, HEALBOT_OPTIONS_BUTTON9)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox10"].Txt, HEALBOT_OPTIONS_BUTTON10)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox11"].Txt, HEALBOT_OPTIONS_BUTTON11)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox12"].Txt, HEALBOT_OPTIONS_BUTTON12)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox13"].Txt, HEALBOT_OPTIONS_BUTTON13)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox14"].Txt, HEALBOT_OPTIONS_BUTTON14)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox15"].Txt, HEALBOT_OPTIONS_BUTTON15)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox16"].Txt, HEALBOT_OPTIONS_BUTTON16)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox17"].Txt, HEALBOT_OPTIONS_BUTTON17)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox18"].Txt, HEALBOT_OPTIONS_BUTTON18)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox19"].Txt, HEALBOT_OPTIONS_BUTTON19)
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionEditBox20"].Txt, HEALBOT_OPTIONS_BUTTON20)
    UIDropDownMenu_SetText(OptionObjects["OptionSetSpellsFor"],HealBot_Plugin_SetSpellsForList[HealBot_Plugin_luVars["SetSpellsForListID"]])	
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionSetSpellsFor"].Txt, HEALBOT_OPTIONS_SETSPELLS)
    UIDropDownMenu_SetText(OptionObjects["OptionSetModifierKey"],HealBot_Plugin_ModifierKeyList[HealBot_Plugin_luVars["ModifierKeyListID"]])	
	HealBot_Plugin_Options_SetLabel(OptionObjects["OptionSetModifierKey"].Txt, HEALBOT_OPTIONS_MODIFIER)
    
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame610"].TextAvoid, HEALBOT_OPTIONS_AVOIDBLUECURSOR)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame610"].TextTarget, HEALBOT_OPTIONS_COMBOAUTOTARGET)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame610"].TextTrinket, HEALBOT_OPTIONS_COMBOAUTOTRINKET)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame610"].TextBinds, HEALBOT_OPTIONS_COMBOBINDS)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1115"].TextAvoid, HEALBOT_OPTIONS_AVOIDBLUECURSOR)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1115"].TextTarget, HEALBOT_OPTIONS_COMBOAUTOTARGET)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1115"].TextTrinket, HEALBOT_OPTIONS_COMBOAUTOTRINKET)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1115"].TextBinds, HEALBOT_OPTIONS_COMBOBINDS)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1620"].TextAvoid, HEALBOT_OPTIONS_AVOIDBLUECURSOR)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1620"].TextTarget, HEALBOT_OPTIONS_COMBOAUTOTARGET)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1620"].TextTrinket, HEALBOT_OPTIONS_COMBOAUTOTRINKET)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1620"].TextBinds, HEALBOT_OPTIONS_COMBOBINDS)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame610"].Txt, HEALBOT_WORD_VERSION..": "..HealBot_Plugin_luVars["Version"])
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1115"].Txt, HEALBOT_WORD_VERSION..": "..HealBot_Plugin_luVars["Version"])
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1620"].Txt, HEALBOT_WORD_VERSION..": "..HealBot_Plugin_luVars["Version"])
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame610"].TxtBindsNote1, HEALBOT_OPTIONS_BINDKEYTOCLICK1)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame610"].TxtBindsNote2, HEALBOT_OPTIONS_BINDKEYTOCLICK2)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1115"].TxtBindsNote1, HEALBOT_OPTIONS_BINDKEYTOCLICK1)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1115"].TxtBindsNote2, HEALBOT_OPTIONS_BINDKEYTOCLICK2)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1620"].TxtBindsNote1, HEALBOT_OPTIONS_BINDKEYTOCLICK1)
    HealBot_Plugin_Options_SetLabel(OptionObjects["OptionFrame1620"].TxtBindsNote2, HEALBOT_OPTIONS_BINDKEYTOCLICK2)

    HealBot_Plugin_Options_InitBinds()
    HealBot_Plugin_Options_Timer()
end

function HealBot_Plugin_Options_InitBinds()
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB6"], OptionBinds6_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB6"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[6]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB7"], OptionBinds7_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB7"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[7]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB8"], OptionBinds8_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB8"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[8]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB9"], OptionBinds9_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB9"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[9]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB10"], OptionBinds10_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB10"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[10]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB11"], OptionBinds11_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB11"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[11]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB12"], OptionBinds12_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB12"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[12]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB13"], OptionBinds13_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB13"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[13]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB14"], OptionBinds14_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB14"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[14]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB15"], OptionBinds15_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB15"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[15]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB16"], OptionBinds16_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB16"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[16]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB17"], OptionBinds17_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB17"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[17]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB18"], OptionBinds18_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB18"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[18]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB19"], OptionBinds19_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB19"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[19]] or HEALBOT_WORDS_NONE)
	UIDropDownMenu_Initialize(OptionObjects["OptionBindsB20"], OptionBinds20_DropDown)
    UIDropDownMenu_SetText(OptionObjects["OptionBindsB20"],HealBot_Plugin_BindsKeyListRead[HealBot_Config_Spells.Binds[20]] or HEALBOT_WORDS_NONE)
end

function HealBot_Plugin_ExtraButtons_Options()
	HealBot_Plugin_Options_ExtraButtons()
	if not HealBot_Plugin_luVars["optionsInit"] then
        HealBot_Plugin_luVars["Version"] = GetAddOnMetadata(HealBot_Plugin_luVars["addonId"], "Version") or 0
		local pId=HealBot_Plugin_luVars["pluginId"]
		OptionObjects["OptionUse"] = CreateFrame("CheckButton", "HealBot_"..pId.."_Frame_Use", HealBot_Plugin_luVars["OptionsFrame"], "UICheckButtonTemplate")
		OptionObjects["OptionUse"]:SetPoint("TOP", -40, -40)
		OptionObjects["OptionUse"]:SetScript("OnClick", function() HealBot_Plugin_OnClick(OptionObjects["OptionUse"]); end)
		OptionObjects["OptionUse"]:SetChecked(HealBot_Globals.PluginExtraButtons)		
	end
	HealBot_Plugin_Options()
	HealBot_Plugin_InUse()
end

function HealBot_Plugin_ExtraButtons_Options_Timer()
  -- call with:   HealBot_Plugin_Options_Timer()
    HealBot_Plugin_luVars["optionsTimer"]=false
    if HealBot_Plugin_luVars["optionsInit"] then
        HealBot_Plugin_Options_SetValues()
    end
end